# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la autodestruccion del sistema
#

require 'rake'

class AutodestruccionController < ApplicationController
  before_filter :restrict_to_development
 
  def index
    unless params[:selector] && params[:selector][:modo] && params[:selector][:numero]
      @modos = [ ['No crear entorno de Formación (dejar recién instalada)',0],
               ['Sólo Crear (dejar en estado de contacto)',1],
               ['Crear y Configuar (dejar en estado de formulación)',2],
               ['Crear, configurar y formular (dejar en estado de ejecución)',3]
             ]
      @numeros = Array.new(30){|x| [x+1, x+1] }
      render 'comunes/autodestruccion'
    else
      logger.warn "------> Autodestruccion invocada por " + @usuario_identificado.nombre
      previo = "RAILS_ENV=development"
      if ENV["GOR_SITEID"]
        previo += " GOR_SITEID=" + ENV['GOR_SITEID']
      end
      previo = ""
      logger.info "------> Recreando la BBDD"
      %x(#{previo} bundle exec rake db:drop db:create)
      logger.info "------> Cargando la BBDD"
      %x(#{previo} bundle exec rake db:migrate)
      logger.info "------> Generando el entorno de formacion"
      %x(#{previo} bundle exec rake db:seed formacion:genera[#{params[:selector][:numero]},#{params[:selector][:modo]}]) 
      redirect_to proyectos_path
    end
  end

 private
  def restrict_to_development
    redirect_to proyectos_path unless params[:seccion] == "administracion" && Rails.env.development?
  end
end
