# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# metodos de navegación utilizados en el layout 

module LayoutHelper

  def ruta_seccion
    case params[:seccion]
      when "administracion" then
        cadena = _("Administración del sistema")
      when "proyectos" then
        if @proyecto
          cadena = _("Proyecto")
          cadena = _("Convenio") if @proyecto.convenio?
          # Para los PACs dejamos como enlace el convenio
          if @proyecto.convenio_id
            ruta_convenio = {:menu => :resumen, :controller => :info, :action => :index, :proyecto_id => @proyecto.convenio_id} 
            cadena = _("PAC") + " (" + link_to(truncate(h(@proyecto.convenio.nombre), :length =>20), ruta_convenio) + ")"
          end
          cadena += " : " + h(@proyecto.nombre)
        else
          cadena = _("Listado de Proyectos y Convenios asignados")
        end
      when "socios" then
        cadena = _("Gestión de socios")
      when "cuadromando" then
        cadena = _("Cuadro de Mando")
      when "agentes" then
	cadena = _("Agente") 
        cadena += "&nbsp;:&nbsp;"
        if @agente
          cadena += h(@agente.nombre)
        else
          cadena += _("Listado de agentes asignados")
        end
      when "inicio" then
        cadena = _("Usuario") + " <i>".html_safe + h(@usuario_identificado.nombre) + "</i>".html_safe
      when "documentos" then
        cadena = _("Documentos Comunes")
      else
        cadena = params[:seccion]
    end
    return cadena.html_safe
  end

  def menu 
    texto_menu = (menu_seccion.find {|c| c[:url][:menu] == params[:menu]})[:rotulo] if params[:menu]
    unless params[:menu]
      obj_menu = menu_seccion.find {|c| c[:url][:controller] == params[:controller]}
      texto_menu = obj_menu[:rotulo] if obj_menu
      texto_menu = "NULL" unless obj_menu
    end
    unless menu_seccion.size == 1 # Si solo hay un controlador no pìntamos el menu
      cadena_menu = "<ul class='menu'>"
      for menu in menu_seccion
         cadena_menu += "<li>" + link_to(menu[:rotulo], menu[:url]) + "</li>" unless (@proyecto && @proyecto.convenio? && !menu[:convenio])
      end
      cadena_menu += "</ul>"
    end
    cadena = link_to(texto_menu, :controller => params[:controller])
    return cadena << (cadena_menu || "").html_safe
  end

  def menu_acciones otros={}
    cadena_acciones = "<ul class='menu'>"
    acciones = controladores_menu
    texto_accion = acciones.find {|c| c[:url][:controller] == params[:controller]}[:rotulo] 
    for menu in controladores_menu otros
      unless @proyecto && ( (@proyecto.convenio_id && menu[:pac] == false) || (@proyecto.convenio? && menu[:convenio] == false) || (@proyecto.convenio_id.nil? && menu[:proyecto] == false) )
        texto_accion = menu[:rotulo] if menu[:url][:controller] == params[:controller] and (  menu[:url][:action] ?  menu[:url][:action] == params[:action] : true )
        cadena_acciones += "<li>" + link_to(menu[:rotulo] , menu[:url]) + "</li>"
      end
    end
    cadena_acciones += "</ul>"
    cadena = link_to( (otros[:menu] ? "" : texto_accion))
    return cadena << cadena_acciones.html_safe
  end


  # Para cada seccion se definen aqui los controladores a los que se tendran acceso.
  # TODO: Estaria bien que cambiemos esto por controladores_administracionministracionministracion, controladores_proyectos, controladores_ ... etc
  def menu_seccion 

     case params[:seccion] 
        when "cuadromando"
            #[	{:rotulo => _("Cuadro de Mando Técnico"), :url => {:menu => "tecnico"}}, 
	     [	{:rotulo => _("Cuadro de Mando Económico"), :url => {:menu => "economico"}} ]
        when "proyectos"
            if params[:action] == "listado_usuario"
              []
            else
              [ { :rotulo => _("Resumen"), :convenio => true, :url => {:menu => "resumen", :controller => "info"} },
		{ :rotulo => _("Configuración"), :convenio => true, :url => {:menu => "configuracion", :controller => "estado"} },
		{ :rotulo => _("Formulacion"), :convenio => true, :url => { :menu => "formulacion", :controller => "matriz"} },
		{ :rotulo => _("Ejecución Técnica"), :convenio => true, :url => { :menu => "ejecucion_tecnica", :controller => "cronograma", :action => "listado"} },
                { :rotulo => _("Ejecución Económica"), :convenio => false, :url => { :menu => "ejecucion_economica", :controller => "gasto_proyectos"} },
		{ :rotulo => _("Documentos"), :convenio => true, :url => { :menu => "documentos_proyecto", :controller => "documento"} }]
            end
        when "agentes"
          if params[:action] == "listado_usuario"
            []
          else
            [ { :rotulo => _("Resumen"), :url => {:menu => "resumen_agente", :controller => "info"} },
              { :rotulo => _("Configuración"), :url => {:menu => "configuracion_agente", :controller => "datos_agente"} },
              { :rotulo => _("Gestión Económica"), :url => {:menu => "economico_agente", :controller => "presupuesto_agentes"} },
              { :rotulo => _("Documentos"), :url => { :menu => "documentos_agente", :controller => "documento"} }]
          #  [   { :rotulo => _("Datos generales"), :url => {:menu => "datos_agente",:controller => "datos_agente" }},
          #      { :rotulo => _("Tareas"), :url => {:menu => "tarea", :controller => "tarea" }},
          #      { :rotulo => _("Presupuesto"), :url => {:menu => "presupuesto_agente",:controller => "presupuesto_agentes" }},
          #      { :rotulo => _("Gastos"), :url => {:menu => "gasto_agente",:controller => "gasto_agentes" }},
          #      { :rotulo => _("Movimientos"), :url => {:menu => "movimientos_agente", :controller => "transferencia"}},
          #      { :rotulo => _("Resumen"), :url => {:menu => "resumen_agente", :controller => "resumen_agente"}},
          #      { :rotulo => _("Exportación e importación") , :url => {:menu => "exportacion_importacion",:controller => "exportacion"}},
          #      { :rotulo => _("Documentos"), :convenio => true, :url => { :menu => "documentos_agente", :controller => "documento"} }]
           end
        when "administracion"
            [ { :rotulo => _("Agentes"), :url => {:menu => "agente", :controller => "agente"}},
              { :rotulo => _("Cuentas"), :url => {:menu => "cuentas", :controller => "libro"}},
              { :rotulo => _("Proyectos"), :url => {:menu => "proyecto", :controller => "proyecto"}},
              { :rotulo => _("Usuarios"), :url => {:menu => "usuario", :controller => "usuario"}},
              { :rotulo => _("Grupos de Usuarios"), :url => {:menu => "grupo", :controller => "grupo_usuario"}},
              { :rotulo => _("Etiquetas"),  :url => {:menu => "etiqueta", :controller => "etiqueta"}},
              { :rotulo => _("Espacios"),  :url => {:menu => "espacio", :controller => "espacio"}},
              { :rotulo => _("Configuración del sistema"), :url => {:menu => "datos_configuracion", :controller => "datos_basicos"}} , ]
        when "socios"
            [ {:rotulo => _("Socios"),  :url => {:menu => "gestion_socios", :controller => "socio"}},
              {:rotulo => _("Listado de Pagos"),  :url => {:menu =>"pagos_socios", :controller => "pago_socio"}},
              {:rotulo => _("Generar Pagos"), :url => {:menu => "pagos_socios", :controller => "pago_socio", :action => "generar_pagos"}},
              {:rotulo => _("Vista Resumen Socios"),  :url => {:menu => "resumen_socios", :controller => "resumen_socio"}}]

        when "documentos"
            [ {:rotulo => _("Documentos generales"), :url => {:menu => "documentos_generales", :controlador => "documento"}}]

        when "inicio"
            [ {:rotulo => _("Vista general"), :url => {:controller => "info"}},
              {:rotulo => _("Tareas"), :url => {:controller => "tarea"}} ]
        else
          []
      end
  end

  # Se llama al metodo menu_acciones del controlador en el que nos encontramos para ver las acciones que ofrece para la navegacion dicho controlador en dicha seccion.
  def controladores_menu otros={}
  menu = (otros[:menu] || params[:menu])
  case menu
    when "resumen"
      [{:rotulo => _("Cuadro resumen"), :url => { :controller => "info" } }, 
       {:rotulo => _("Tareas"), :url => { :controller => "tarea" } }, 
       {:rotulo => _("Resumen Matriz"), :url => { :controller => "resumen_proyecto", :action => "matriz"}},
       {:rotulo => _("Resumen Presupuesto"), :url => { :controller => "resumen_proyecto", :action => "presupuesto"}},
       {:rotulo => _("Resumen Gasto"), :url => { :controller => "resumen_proyecto", :action => "gasto"}},
       {:rotulo => _("Arqueos de caja/cuenta"), :url => { :controller => "resumen_proyecto", :action => "arqueo_caja"}},
       {:rotulo => _("Resumen de Transferencias"), :url => { :controller => "resumen_proyecto", :action => "transferencia"}},
       {:rotulo => _("Resumen Tesoreria"), :url => { :controller => "resumen_proyecto", :action => "estado_tesoreria"}},
       {:rotulo => _("Resumen de Proveedores"), :url => { :controller => "resumen", :action => "proveedor"}},
       {:rotulo => _("Resumen de Seguimiento Técnico"), :url => { :controller => "resumen_proyecto", :action => "seguimiento_tecnico"}}, ]

    when "resumen_agente"
      [{:rotulo => _("Cuadro resumen"), :url => {:controller => "info"}},
       {:rotulo => _("Tareas"), :url => {:controller => "tarea"}},
       {:rotulo => _("Presupuesto"), :url => {:controller => "resumen_agente" ,:action => "presupuesto"}},
       {:rotulo => _("Seguimiento Gasto"), :url => {:controller => "resumen_agente" ,:action => "gasto"}},
       {:rotulo => _("Arqueo de Cuenta/Caja"), :url => {:controller => "resumen_agente" ,:action => "arqueo_caja"}},
       {:rotulo => _("Transferencias a Proyectos"), :url => {:controller => "resumen_agente", :action => "transferencia"}},
       {:rotulo => _("Resumen de Proveedores"), :url => {:controller => "resumen", :action => "proveedor"}},
       {:rotulo => _("Seguimiento convocatorias"), :url => {:controller => "convocatoria"}}  ]

    when "configuracion"
      [{:rotulo => _("Estado del proyecto"), :url => { :controller => "estado" } }, 
       {:rotulo => _("Etapas y tasas de cambio"), :url => { :controller => "datos_proyecto", :action => "etapas" } }, 
       {:rotulo => _("Relaciones del proyecto"), :pac => false, :url => { :controller => "datos_proyecto", :action => "relaciones"}},
       {:rotulo => _("Proyectos cofinanciadores"), :convenio => false, :url => { :controller => "datos_proyecto", :action => "proyecto_cofinanciador"}},
       {:rotulo => _("Partidas del financiador"), :pac => false, :url => { :controller => "partida_financiacion"}},
       {:rotulo => _("Subpartidas"), :pac => false, :url => {:controller => "subpartida"}},
       {:rotulo => _("Cálculo de Remanentes"), :convenio => false, :proyecto => false, :url => { :controller => "remanente", :action => "index"}},
       {:rotulo => _("Exportación partidas/subpartidas"), :pac => false, :url => { :controller => "exportacion" } },
       {:rotulo => _("Importación partidas/subpartidas"), :pac => false, :url => { :controller => "importacion" } }   ]

    when "configuracion_agente"
      [{ :rotulo => _("Etapas y tasas de cambio"),:url => {:controller => "datos_agente", :action => "etapas"}},
       { :rotulo => _("Subpartidas del agente"), :url => {:controller => "subpartida"}},
       { :rotulo => _("Monedas del agente"), :url => {:controller => "datos_agente", :action => "monedas" }},
       { :rotulo => _("Convocatorias"), :url => {:controller => "convocatoria", :action => "listado" }},
       { :rotulo => _("Proyectos gestionados"), :url => {:controller => "proyecto", :action => "listado" }},
       { :rotulo => _("Libros del agente"), :url => {:controller => "libro", :action => "listado"}} ]

    when "formulacion"
      [{:rotulo => _("Matriz"), :url => { :controller => "matriz", :action => "matriz" } },
       {:rotulo => _("Subactividades"), :convenio => false, :url => { :controller => "matriz", :action => "subactividades" } },
       {:rotulo => _("Cronograma"), :url => { :controller => "cronograma", :action => "listado" } },
       {:rotulo => _("Indicadores"), :url => { :controller => "indicador", :action => "listado" } },
       {:rotulo => _("Información del Proyecto"), :url => { :controller => "datos_proyecto_dinamicos", :action => "listado" } },
       {:rotulo => _("Datos titulares derecho"), :url => { :controller => "datos_proyecto", :action => "beneficiarios" } },  
       #{:rotulo => _("Datos objetivos"), :url => { :controller => "datos_proyecto", :action => "datos_proyecto_dinamicos_objetivos" } },  
       {:rotulo => _("Presupuesto por partidas"), :url => { :controller => "presupuesto_proyectos" } }, 
       {:rotulo => _("Presupuesto por actividades"), :url => { :controller => "presupuesto_actividad", :action => "listado" } }, 
       {:rotulo => _("Exportación matriz/presupuesto"), :url => { :controller => "exportacion" } }, 
       {:rotulo => _("Importación matriz/presupuesto"), :url => { :controller => "importacion" } }] 
 
    when "ejecucion_tecnica"
      [{:rotulo => _("Cronograma de Seguimiento"), :url => { :controller => "cronograma", :action => "listado" } },
       {:rotulo => _("Seguimiento de OEs y Resultados"), :url => { :controller => "matriz", :action => "matriz" } },
       {:rotulo => _("Seguimiento Actividades"), :url => { :controller => "actividad", :action => "listado" } },
       {:rotulo => _("Seguimiento Indicadores"), :url => { :controller => "indicador", :action => "listado" } },
       {:rotulo => _("Seguimiento Fuentes de Verificación"), :url => { :controller => "fuente_verificacion", :action => "listado_fuentes_verificacion" } },
       {:rotulo => _("Información de Seguimiento"), :url => { :controller => "datos_proyecto_dinamicos", :action => "listado" } } ]

    when "ejecucion_economica"
      [{:rotulo => _("Gastos"), :convenio => false, :url => { :controller => "gasto_proyectos" } },
       {:rotulo => _("Gastos cofinanciables"), :convenio => false, :url => { :controller => "gasto_proyectos", :action => "cofinanciables" } },
       {:rotulo => _("Numeración facturas"), :convenio => false, :url => { :controller => "gasto_proyectos", :action => "listado_facturas" } },
       {:rotulo => _("Movimientos"), :convenio => false, :url => { :controller => "transferencia" } },
       {:rotulo => _("Exportación gastos/movimientos"), :convenio => false, :url => { :controller => "exportacion" } },
       {:rotulo => _("Importación gastos/movimientos"), :convenio => false, :url => { :controller => "importacion" } }] 

    when "economico_agente"
      [{:rotulo => _("Presupuesto"), :url => {:controller => "presupuesto_agentes" }}, 
       {:rotulo => _("Gastos"), :url => {:controller => "gasto_agentes" }},
       {:rotulo => _("Movimientos"), :url => {:controller => "transferencia"}},
       {:rotulo => _("Exportación gastos/movimientos"), :url => { :controller => "exportacion" }},
       {:rotulo => _("Importación gastos/movimientos"), :url => {:controller => "importacion" }}]

    when "datos_configuracion"
        [{ :rotulo => _("País"),:url => {:controller => "datos_basicos", :action => "listado_pais"}},
         { :rotulo => _("Area Geográfica"),:url => {:controller => "datos_basicos", :action => "listado_area_geografica"}},
         { :rotulo => _("Monedas"),:url => {:controller => "datos_basicos", :action => "listado_moneda"}},
         { :rotulo => _("Grupos de Datos de Proyecto"), :url => {:controller => "datos_basicos", :action => "listado_grupo_dato_dinamico"}},
         { :rotulo => _("Datos de proyecto"),:url => {:controller => "datos_basicos", :action => "listado_definicion_dato"}},
         { :rotulo => _("Sector de Intervención"),:url => {:controller => "datos_basicos", :action => "listado_sector_intervencion"}},
         { :rotulo => _("Sector de Población"),:url => {:controller => "datos_basicos", :action => "listado_sector_poblacion"}},
         { :rotulo => _("Area de Actuación"),:url => {:controller => "datos_basicos", :action => "listado_area_actuacion"}},
         { :rotulo => _("Workflow"),  :url => {:controller => "definicion_estado"}},
         { :rotulo => _("Partidas"),:url => {:controller => "datos_basicos", :action => "listado_partida"}},
         { :rotulo => _("Tipo tareas"),:url => {:controller => "datos_basicos", :action => "listado_tipo_tarea"}},
         { :rotulo => _("Estado tareas"),:url => {:controller => "datos_basicos", :action => "listado_estado_tarea"}},
         { :rotulo => _("Subtipos de Movimiento"), :url => {:controller => "datos_basicos", :action => "listado_subtipo_movimiento"}},
         { :rotulo => _("Etiquetas Técnicas"), :url => {:controller => "datos_basicos", :action => "listado_etiqueta_tecnica"}},
         { :rotulo => _("Marcado"), :url => {:controller => "datos_basicos", :action => "listado_marcado"}},
         { :rotulo => _("Plantillas de Exportación"),:url => {:controller => "documento"}},
         { :rotulo => _("Backup"),  :url => {:controller => "backup"}}]
    
    when "documentos_proyecto"
         [{:rotulo => (_"Documentos por espacios"), :url => { :controller => "documento", :action => "index"}},
          {:rotulo => _("Busqueda por etiquetas"), :url => { :controller => "documento_busqueda", :action => "index"}},
          {:rotulo => _("Documentos de gastos"), :url => { :controller => "documento_busqueda", :action => "listado_gastos"}},
          {:rotulo => _("Documentos de transferencias"), :url => { :controller => "documento_busqueda", :action => "listado_transferencias"}}] 

    when "documentos_agente"
         [{:rotulo => (_"Documentos por espacios"), :url => { :controller => "documento", :action => "index"}},
          {:rotulo => _("Documentos de gastos"), :url => { :controller => "documento_busqueda", :action => "listado_gastos"}},
          {:rotulo => _("Documentos de transferencias"), :url => { :controller => "documento_busqueda", :action => "listado_transferencias"}}] 

    when "documentos_generales"
         [{:rotulo => (_"Documentos por espacios"), :url => { :controller => "documento", :action => "index"}},
          {:rotulo => _("Busqueda por etiquetas"), :url => { :controller => "documento_busqueda", :action => "index"}}] 
    else
      []
    end
  end

  # Genera un boton de información
  def mensaje_informacion
    objeto_id = "ayuda_menu"
    cadena = ('<span id="' + objeto_id + '" class="popup_link">').html_safe + icono("informacion", _("Ayuda")) + '</span>'.html_safe
    cadena << ('<div id="' + objeto_id + '_popup" class="popup" style="display:none">').html_safe
    texto_ayuda(params[:seccion], params[:controller], params[:action]).each do |linea|
      cadena << simple_format(linea)
    end
    cadena << eval( 'javascript_tag "new Popup(\"' + objeto_id + '_popup\",\"' + objeto_id + '\", {position:\'auto\',trigger:\'click\'} )"' ).html_safe
    return cadena << '</div>'.html_safe
  end

end
