# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VGasto < ActiveRecord::Base
  #untranslate_all
  # valores =  proyecto_id (0), moneda_id (1), implementador_id (2), fecha_inicio (3), fecha_fin (4), tasa_cambio (5)

  scope :partida_de_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id,  partida_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

  scope :partida_de_implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[0], valores[4]} as importe", 
                                 :group => "partida_id #{moneda valores[0]} #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador")  } }

  scope :partida_de_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :actividad_de_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador", :partida => valores[6])  } }

                                    
  scope :actividad_de_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador", :partida => valores[6])  } }

  scope :partida_proyecto_de_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

  # Cruza actividades y partidas para una moneda y un implementador
  scope :actividad_por_partida, lambda { |*valores| {
				:select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe",
				:group => "proyecto_id, partida_proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
				:conditions=> condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }
                                    
  scope :partida_proyecto_de_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores [7])  } }

  scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores [7])  } }


  scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores[7], :subpartida => (valores[8] || "isnull") ) } }

  scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores[7], :subpartida => (valores[8] || "isnull") ) } }


     
  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.moneda moneda_id
      return moneda_id == "todas" ? "" : ", moneda_id "
  end

  def self.agente agente_id, agente_rol
      return agente_id == "todos" ? "" : ", #{agente_rol}_id "
  end

  def self.condiciones proyecto_id, moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol, otros={}
     condiciones = {"proyecto_id" => proyecto_id, "fecha" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end

  def self.condiciones_sin_proyecto moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol
     condiciones = {"fecha" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     return condiciones
  end

 # +++
 # Sobrecargamos la clase para incluir agrupaciones 
 # ---
 class << self

  # Para agrupaciones de datos, tenemos que construir la tabla columna a columna
  def partida_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    # Informacion del financiador principal
    datos  = agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.agente.id, fecha_inicio, fecha_fin, tasa_cambio, '0')
    # Otras aportaciones publicas externas
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio, '1')
    # ONG/Agrupacion externa
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio, '2')
    # Otras aportaciones privadas externas
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio, '3')
    # ONG Local
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio, '4')
    # Aportaciones publicas locales
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio, '5')
    # Aportaciones privadas locales
    datos += agrupa_partida_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio, '6')
    return datos
  end

  def partida_proyecto_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    # Informacion del financiador principal
    datos  = agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.agente.id, fecha_inicio, fecha_fin, tasa_cambio, '0')
    # Otras aportaciones publicas externas
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio, '1')
    # ONG/Agrupacion externa
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio, '2')
    # Otras aportaciones privadas externas
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio, '3')
    # ONG Local
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio, '4')
    # Aportaciones publicas locales
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio, '5')
    # Aportaciones privadas locales
    datos += agrupa_partida_proyecto_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio, '6')
    return datos
  end

  def actividad_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil
    proyecto = Proyecto.find_by_id proyecto_id
    # Informacion del financiador principal
    datos  = agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.agente.id, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '0')
    # Otras aportaciones publicas externas
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '1')
    # ONG/Agrupacion externa
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '2')
    # Otras aportaciones privadas externas
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '3')
    # ONG Local
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '4')
    # Aportaciones publicas locales
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '5')
    # Aportaciones privadas locales
    datos += agrupa_actividad_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '6')
    return datos
  end

  def resultado_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil
    proyecto = Proyecto.find_by_id proyecto_id
    # Informacion del financiador principal
    datos  = agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.agente.id, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '0')
    # Otras aportaciones publicas externas
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '1')
    # ONG/Agrupacion externa
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '2')
    # Otras aportaciones privadas externas
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '3')
    # ONG Local
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '4')
    # Aportaciones publicas locales
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '5')
    # Aportaciones privadas locales
    datos += agrupa_resultado_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '6')
    return datos
  end

  def oe_financiador_x_grupos proyecto_id, moneda_id, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil
    proyecto = Proyecto.find_by_id proyecto_id
    # Informacion del financiador principal
    datos  = agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.agente.id, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '0')
    # Otras aportaciones publicas externas
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '1')
    # ONG/Agrupacion externa
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '2')
    # Otras aportaciones privadas externas
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_externo_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '3')
    # ONG Local
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_ong, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '4')
    # Aportaciones publicas locales
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_publico, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '5')
    # Aportaciones privadas locales
    datos += agrupa_oe_de_financiador( proyecto.id, moneda_id, proyecto.financiador_local_privado, fecha_inicio, fecha_fin, tasa_cambio, partida_id, '6')
    return datos
  end

  # Devuelve un array de hashes con las partidas agrupadas (correccion para convenios) para financiadores
  def agrupa_partida_proyecto_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = partida_proyecto_de_financiador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = []
      g.each do |p|
        # Hacemos el mapeo del mapeo de partidas
        partida_convenio = proyecto.partida_financiacion.find_by_codigo(PartidaFinanciacion.find_by_id(p.fila_id).codigo)
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => partida_convenio.id } ) if partida_convenio
      end
    else
      g = partida_proyecto_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio 
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end
   
    return gastos
  end

  # Devuelve un array de hashes con las partidas agrupadas (correccion para convenios) para implementadores
  def agrupa_partida_proyecto_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = partida_proyecto_de_implementador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = []
      g.each do |p|
        # Hacemos el mapeo del mapeo de partidas
        partida_convenio = proyecto.partida_financiacion.find_by_codigo(PartidaFinanciacion.find_by_id(p.fila_id).codigo)
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => partida_convenio.id } ) if partida_convenio
      end
    else
      g = partida_proyecto_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    return gastos
  end

  # Devuelve un array de hashes con las partidas de sistema agrupadas (correccion para convenios) para financiadores
  def agrupa_partida_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = partida_de_financiador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = []
      g.each do |p|
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id } )
      end
    else
      g = partida_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    return gastos
  end

  # Devuelve un array de hashes con las partidas de sistema agrupadas (correccion para convenios) para implementadores
  def agrupa_partida_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = partida_de_implementador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = []
      g.each do |p|
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id } )
      end
    else
      g = partida_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    return gastos
  end

  # Devuelve un array de hashes con las actividades del convenio agrupadas (correccion para convenios) para financiadores
  def agrupa_actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = actividad_de_financiador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      gastos = []
      g.each do |p|
        # Hacemos el mapeo del mapeo de actividades
        actividad_proyecto = Actividad.find_by_id(p.fila_id)
        actividad_convenio = actividad_proyecto ? proyecto.actividad.find_by_id(actividad_proyecto.actividad_convenio_id) : nil
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => (actividad_convenio ? actividad_convenio.id : nil) } )
      end
    else
      g = actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    return gastos
  end

  # Devuelve un array de hashes con los resultados del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_resultado_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    gastos_actividades = agrupa_actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
    gastos = []

    # Recorre todas las actividades generando los gastos por resultado
    gastos_actividades.each do |gasto|
      actividad = Actividad.find_by_id gasto["fila_id"]
      # Si no hay actividad ponemos nil y si la hay pero no tiene resultado_id ponemos 0 (acts. generales)
      resultado_id = actividad ? actividad.resultado_id||0 : nil
      gastos = sum_array( gastos, {"columna_id" => columna_id.to_s, "importe" => gasto["importe"], "fila_id" => resultado_id} ) 
    end
    return gastos
  end

  # Devuelve un array de hashes con los oe del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_oe_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    gastos_resultados = agrupa_resultado_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
    gastos = []

    # Recorre todos los resultados generando los gastos por oe 
    gastos_resultados.each do |gasto|
      # Se no habia resultado para la actividad era global, ponemos 0
      if gasto["fila_id"] == 0
        oe_id = 0
      # Si no era con resultado 0 puede que este huerfana de oe o que lo tenga
      else
        resultado = Resultado.find_by_id gasto["fila_id"]
        oe_id = resultado ? resultado.objetivo_especifico_id : nil
      end
      gastos = sum_array( gastos, {"columna_id" => columna_id.to_s, "importe" => gasto["importe"], "fila_id" => oe_id} )
    end
    return gastos
  end

  # Devuelve un array de hashes con las actividades del convenio agrupadas (correccion para convenios) para implementadores
  def agrupa_actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    proyecto = Proyecto.find_by_id(proyecto_id)

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (proyecto.convenio?)
      g = actividad_de_implementador proyecto.pacs.collect{|p| p.id}, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      gastos = []
      g.each do |p|
        # Hacemos el mapeo del mapeo de actividades
        actividad_convenio = proyecto.actividad.find_by_id(Actividad.find_by_id(p.fila_id).actividad_convenio_id)
        gastos = sum_array( gastos, { "columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => actividad_convenio.id } ) if actividad_convenio
      end
    else
      g = actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      gastos = g.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    return gastos
  end

  # Devuelve un array de hashes con los resultados del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_resultado_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    gastos_actividades = agrupa_actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
    gastos = []

    # Recorre todas las actividades generando los gastos por resultado
    gastos_actividades.each do |gasto|
      actividad = Actividad.find_by_id gasto["fila_id"]
      # Si no hay actividad ponemos nil y si la hay pero no tiene resultado_id ponemos 0 (acts. generales)
      resultado_id = actividad ? actividad.resultado_id||0 : nil
      gastos = sum_array( gastos, {"columna_id" => columna_id.to_s, "importe" => gasto["importe"], "fila_id" => resultado_id} )
    end
    return gastos
  end

  # Devuelve un array de hashes con los oe del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_oe_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=2
    gastos_resultados = agrupa_resultado_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
    gastos = []

    # Recorre todos los resultados generando los gastos por oe 
    gastos_resultados.each do |gasto|
      # Se no habia resultado para la actividad era global, ponemos 0
      if gasto["fila_id"] == 0
        oe_id = 0
      # Si no era con resultado 0 puede que este huerfana de oe o que lo tenga
      else
        resultado = Resultado.find_by_id gasto["fila_id"]
        oe_id = resultado ? resultado.objetivo_especifico_id : nil
      end
      gastos = sum_array( gastos, {"columna_id" => columna_id.to_s, "importe" => gasto["importe"], "fila_id" => oe_id} )
    end
    return gastos
  end



  # Metodos privados (suma elementos en el array principal)
  private
  def sum_array total, element
    found = false
    total.each do |el|
      if el["columna_id"] == element["columna_id"] && el["fila_id"] == element["fila_id"]
        el["importe"] += element["importe"]
        found = true
      end 
    end
    total.push element unless found
    return total
  end

 end

end
